#ifndef CLUSTER_H
#define CLUSTER_H

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include "decl.h"
#include "Point.h"
#include "MultiPointQuery.h"

#define MAX_CLUSTERS 500
#define INF 9999999

class Point;  
class MultiPointQuery;

struct cluster
{
  Point centroid;
  float radius;
  int size;
  float sum_of_weights;
};

class Clusters
{
 public:
  struct cluster Clusters[MAX_CLUSTERS]; 
  int graph[MAX_CLUSTERS][MAX_CLUSTERS];
  int graphflag[MAX_CLUSTERS];
  
  int numPoints;     // curr num of points inserted, previously nop_seen
  int numClusters;   // current number of clusters previously curr
  int maxClusters;   // max num of permissible clusters previously NUM
  float minICD;        // curr min intercluster distance
  float alpha;
  float beta;
  float (* dist_func) (Point *, Point *); 
  int dist_metric;
  int use_function;  // flag, which one to use


  Clusters(int max_clusters, float (*User_Distance) (Point *, Point *));
  Clusters(int max_clusters, int Dist_Metric);
  ~Clusters();

  void AddPoint(Point *P, float weight);
  int NumClusters();
  void Compute(MultiPointQuery* mpq);

  // private stuff
  float Distance(Point *P, Point *Q);
  float FindMinICDist();
  int selectminimumbias();
  void OrganizeClusterAfterMerge();
};

#endif
