// Query Expansion //

#include <math.h>
#include "qex.h"
#include "Point.h"
#include "MultiPointQuery.h"
#include "Cluster.h"

QEX::QEX()
{
   clus = NULL; 
}

QEX::~QEX()
{
  if (clus != NULL) {
    delete clus;
    clus = NULL;
  }
}

void QEX::reset(Point *p, float *w, int maxClusters, int dist_metric)
{
  mpq.querypoints = p;
  mpq.weights = w;
  if (clus != NULL) {
    delete clus;
    clus = NULL;
  }

  clus = new Clusters(maxClusters,dist_metric);
}

void QEX::addPoint(Point & p, float weight)
{
    clus->AddPoint(&p, weight);
}

void QEX::compute()
{
    clus->Compute(&mpq);
}


