// Query Point Movement //

#ifndef QPM_H
#define QPM_H

#include "decl.h"
#include "Point.h"

class QPM
{
  public:
    Point centroid; // sum
    Point variance; // sum squared
    float totalWeight;

    QPM();
    ~QPM();
    void reset();

    void addPoint(Point & p, float weight);

    int compute(); 
    // return 0 if no point added or their weights are all zeroes
    
    int weights(float *w); 
    // return 0 if all (dimensional) weights are all zeroes

    // note that there are two different weights
    // one : weight for each point
    // two : weight for each dimension 

};

#endif

